unit mausunit;

INTERFACE

function init: boolean;
procedure ende;
procedure Maus(var taste: byte; var Feld: string; var x, y: word; kurz: boolean);
     {Linke oder rechte Taste gedrueckt?   Welches "Feld"?}
procedure erzeugeFeld( name, beschreib: string; x1, y1, x2, y2: word;
                       cursor: byte; warte: boolean );
procedure loescheFeld(name: string);
procedure versteckeCursor; {Darauf achten, nicht zweimal zu verstecken, }
procedure zeigeCursor;     {oder zu zeigen...}
PROCEDURE SetMouseWindow(x1, y1, x2, y2: INTEGER);

IMPLEMENTATION
uses
  graph;
type
  vCursor = record
              hotx, hoty: byte;
              aussehen: array[0..1, 0..15] of Word;
            end;
  zeiger = ^feld;
  feld = record
           name: string[10];
           beschreib: string[100];
           x1, y1, x2, y2: word;
           naechstes: zeiger;
           cursor: byte;
           warte: boolean;
         end;
const
  box:vCursor=(hotx:9; hoty:8; aussehen:
   (($0000,$7FFE,$7FFE,$7FFE,$7FFE,$7FFE,$7FFE,$7FFE,$7FFE,$7FFE,$7FFE,$7FFE,$7FFE,$7FFE,$7FFE,$0000),
   ($0000,$7FFE,$7FFE,$7FFE,$7FFE,$7FFE,$7FFE,$7FFE,$7FFE,$7FFE,$7FFE,$7FFE,$7FFE,$7FFE,$7FFE,$0000)));
  endCur:vCursor=(hotx:7; hoty:7; aussehen:
   (($0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000),
   ($0000,$7A58,$435C,$4356,$4352,$4352,$4352,$7BD2,$43D2,$42D2,$42D2,$42D2,$42D6,$42DC,$7A58,$0000)));
  stift2: vCursor = (hotx: 0; hoty: 15; aussehen:
   (($FC3F,$F81F,$F80F,$F00F,$F01F,$E01F,$E03F,$C03F,$C07F,$807F,$80FF,$00FF,$01FF,$03FF,$07FF,$8FFF),
   ($0000,$03C0,$0220,$0620,$05C0,$0840,$0880,$1080,$1100,$2100,$3200,$7E00,$7C00,$7800,$7000,$0000)));
  einfuegn: vCursor=(hotx:7; hoty:7; aussehen:
   (($FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF),
   ($0000,$07C0,$0100,$0100,$0100,$0100,$0100,$0100,$0100,$0100,$0100,$0100,$0100,$0100,$07C0,$0000)));
  pfeil3:vCursor=(hotx:1; hoty:1; aussehen:
   (($00FF,$01FF,$03FF,$01FF,$00FF,$007F,$003F,$203F,$707F,$F8FF,$FDFF,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF),
   ($0000,$7C00,$7800,$7C00,$7E00,$7F00,$5F80,$0F80,$0700,$0200,$0000,$0000,$0000,$0000,$0000,$0000)));
  kreuz:vCursor=(hotx:8; hoty:8; aussehen:
   (($3FFC,$1FF8,$8FF1,$C7E3,$E3C7,$F18F,$F81F,$FC3F,$FC3F,$F81F,$F18F,$E3C7,$C7E3,$8FF1,$1FF8,$3FFC),
   ($0000,$4002,$2004,$1008,$0810,$0420,$0240,$0180,$0180,$0240,$0420,$0810,$1008,$2004,$4002,$0000)));
  line:vCursor=(hotx:9; hoty:8; aussehen:
   (($FFFF,$CFF9,$C7F1,$E003,$F007,$F007,$F1C7,$F1C7,$F1C7,$F007,$F007,$E003,$C7F1,$CFF9,$FFFF,$FFFF),
   ($0000,$3006,$280A,$17F4,$0808,$0BE8,$0A28,$0A28,$0A28,$0BE8,$0808,$17F4,$280A,$3006,$0000,$0000)));
  zielkreu:vCursor=(hotx:7; hoty:7; aussehen:
   (($FEFF,$FEFF,$FEFF,$FEFF,$FC7F,$FBBF,$F7DF,$06C1,$F7DF,$FBBF,$FC7F,$FEFF,$FEFF,$FEFF,$FEFF,$FFFF),
   ($0100,$0100,$0100,$0100,$0380,$0440,$0820,$F93E,$0820,$0440,$0380,$0100,$0100,$0100,$0100,$0000)));
  zielwahl:vCursor=(hotx:7; hoty:7; aussehen:
   (($FEFF,$FEFF,$FEFF,$FEFF,$FC7F,$FBBF,$F7DF,$06C1,$F7DF,$FBBF,$FC7F,$FEFF,$FEFF,$FEFF,$FEFF,$FFFF),
   ($FFFE,$FFFE,$FFFE,$FFFE,$FFFE,$FFFE,$FFFE,$FFFE,$FFFE,$FFFE,$FFFE,$FFFE,$FFFE,$FFFE,$FFFE,$0000)));
  s_links: vCursor = (hotx: 0; hoty: 7; aussehen:
   (($FFFF,$FFFF,$FFFF,$FFFF,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF),
   ($0000,$0000,$0000,$0000,$0000,$7FFE,$5FFE,$FFFE,$5FFE,$7FFE,$0000,$0000,$0000,$0000,$0000,$0000)));
  s_rechts: vCursor = (hotx: 15; hoty: 7; aussehen:
   (($FFFF,$FFFF,$FFFF,$FFFF,$0000,$0000,$0000,$0000,$0000,$0000,$0000,$FFFF,$FFFF,$FFFF,$FFFF,$FFFF),
   ($0000,$0000,$0000,$0000,$0000,$7FFE,$7FFA,$7FFF,$7FFA,$7FFE,$0000,$0000,$0000,$0000,$0000,$0000)));
  s_oben: vCursor = (hotx: 8; hoty: 0; aussehen:
   (($F80F,$F80F,$F80F,$F80F,$F80F,$F80F,$F80F,$F80F,$F80F,$F80F,$F80F,$F80F,$F80F,$F80F,$F80F,$F80F),
   ($0080,$03E0,$02A0,$03E0,$03E0,$03E0,$03E0,$03E0,$03E0,$03E0,$03E0,$03E0,$03E0,$03E0,$03E0,$0000)));
  s_unten: vCursor = (hotx: 8; hoty: 15; aussehen:
   (($F80F,$F80F,$F80F,$F80F,$F80F,$F80F,$F80F,$F80F,$F80F,$F80F,$F80F,$F80F,$F80F,$F80F,$F80F,$F80F),
   ($0000,$03E0,$03E0,$03E0,$03E0,$03E0,$03E0,$03E0,$03E0,$03E0,$03E0,$03E0,$03E0,$02A0,$03E0,$0080)));

var
  anker: zeiger;
  aktcursor: byte;
  aktzeiger: vCursor;
  m: Array[1..4] Of Word;

PROCEDURE Mausasm(var m: array of word);
BEGIN
  ASM
    LES DI,m
    MOV AX,ES:[DI]
    MOV BX,ES:[DI+2]
    MOV CX,ES:[DI+4]
    MOV DX,ES:[DI+6]
    INT $33
    MOV ES:[DI],AX
    MOV ES:[DI+2],BX
    MOV ES:[DI+4],CX
    MOV ES:[DI+6],DX
  END;
END;

PROCEDURE SetMouseWindow(x1, y1, x2, y2: INTEGER); ASSEMBLER;
ASM
  MOV  AX, 0007h
  MOV  CX, x1
  MOV  DX, x2
  INT  33h
  MOV  AX, 0008h
  MOV  CX, y1
  MOV  DX, y2
  INT  33h
END;

procedure cursorWechsel(neuCursor: byte);
  PROCEDURE LES; ASSEMBLER;
  ASM
    MOV AX,Seg(aktzeiger.aussehen)
    MOV ES,AX
  END;
begin
{  Sound(220); Delay(100); NoSound;}
  aktcursor:= neuCursor;
  case neuCursor of
     1: aktzeiger:= pfeil3;
     2: aktzeiger:= stift2;
     3: aktzeiger:= einfuegn;
     4: aktzeiger:= box;
     5: aktzeiger:= endCur;
     6: aktzeiger:= kreuz;
     7: aktzeiger:= zielwahl;
     8: aktzeiger:= zielkreu;
     9: aktzeiger:= s_links;
     10: aktzeiger:= s_oben;
     11: aktzeiger:= s_rechts;
     12: aktzeiger:= s_unten;
   else aktzeiger:= kreuz;
  end;
  m[1]:=2; mausasm(m);
  m[1]:=9;
  with aktzeiger do
  begin
    m[2]:=hotx;
    m[3]:=hoty;
    m[4]:=Ofs(aussehen);
  end;
  LES; mausasm(m);
  m[1]:=1; mausasm(m);
  m[1]:=3; mausasm(m);
end;

procedure zeigeCursor; assembler;
ASM
  MOV AX, 0001h
  INT 33h
END;

procedure versteckeCursor; assembler;
ASM
  MOV AX, 0002h
  INT 33h
END;

procedure LoescheFeld(name: string);
var
  lauf, vorgaenger: zeiger;
begin
  lauf:= anker;
  if lauf^.name = name then anker:= lauf^.naechstes else
    begin
      vorgaenger:= lauf;
      lauf:= lauf^.naechstes;
      while lauf <> nil do
        if lauf^.name = name then
        begin
          vorgaenger^.naechstes:= lauf^.naechstes;
          lauf:= nil;
        end
        else
        begin
          vorgaenger:= lauf;
          lauf:= lauf^.naechstes;
        end;
    end;
end;

procedure ErzeugeFeld(name, beschreib: string; x1, y1, x2, y2: word;
                      cursor: byte; warte: boolean);
var
  neu: zeiger;
begin
  new(neu);
  neu^.naechstes:= nil;
  neu^.name:= name;
  neu^.beschreib:= beschreib;
  neu^.x1:= x1;
  neu^.y1:= y1;
  neu^.x2:= x2;
  neu^.y2:= y2;
  neu^.cursor:= cursor;
  neu^.warte:= warte;
  if anker = nil then anker:= neu else
  begin
    neu^.naechstes:= anker;
    anker:= neu;
  end;
end;

function init: boolean;
begin
  anker:= nil;
  if Mem[MemW[0:$cc+2]:MemW[0:$cc]] = $cf then init:= false else                           {mouse.com gestartet?}
  begin
    m[1]:=0;
    Mausasm(m);       {0 = Initialisierung}
    m[1]:=1;
    Mausasm(m);       {1 = sichtbar machen}
    m[1]:=3;
    Mausasm(m);       {3 = Daten uebermitteln}
    aktcursor:= 0;
    init:= true;
  end;
end;

procedure beschreibung(text: string; m3, m4: word);
const
  vorlauf = 10;
  dauer = 100;
var
  oTicks: longint;
  ticks: longint absolute $0000:$046C;
  groesse: word;
  x1, x2, y1, y2: integer;
  bild: pointer;
  aktiv: boolean;
  procedure aktiviere;
  var
    fuell: fillsettingstype;
    altfarbe: word;
    xmf: byte;
  begin
    if getmaxx = 319 then xmf:= 2 else xmf:= 1;
    altfarbe:= getcolor;
    getfillsettings(fuell);
    setcolor(0);
    setfillstyle(1,15);
    if (m3 div xmf + length(text) * 8) < getmaxx then
      if m3 div xmf > 3 then x1:= (m3 div xmf - 3) else x1:= 0
    else x1:=(m3 div xmf - (m3 div xmf + length(text) * 8 - getmaxx) - 4);
    x2:= (x1 + 8 * length(text) + 3);
    if x2 >= getmaxx then x2:= (getmaxx-1);
    if x1 < 1 then x1:= 1;
    if m4 < (getmaxy - 25) then y1:= (m4 + 17)
                           else y1:= (m4 - 15);
    y2:= (y1 + 10);
    groesse:= imagesize(x1,y1,x2,y2);
    getmem(bild, groesse);
    versteckeCursor;
    getImage(x1, y1, x2, y2, bild^);
    bar(x1, y1, x2, y2);
    outtextxy( (x1 + 2), (y1 + 2), text );
    zeigeCursor;
    setcolor(altfarbe);
    setfillstyle(fuell.pattern, fuell.color);
  end;
  procedure deaktiviere;
  begin
    versteckeCursor;
    putImage(x1, y1, bild^, normalput);
    freeMem(bild, groesse);
    zeigeCursor;
  end;
begin
  if text <> '' then
  begin
    oTicks:= ticks;
    aktiv:= FALSE;
    mausASM(m);
    while (m3 = m[3]) and (m4 = m[4]) and (m[2] = 0) do
    begin
      if ticks < ( oTicks + vorlauf + dauer) then
      begin
        if (ticks > (oTicks + vorlauf)) and not(aktiv) then
        begin
          aktiviere;
          aktiv:= true;
        end;
      end
      else
      begin
        if aktiv then deaktiviere;
        aktiv:= false;
      end;
      m3:= m[3];
      m4:= m[4];
      mausASM(m);
    end;
    if aktiv then deaktiviere;
  end;
end;

procedure Maus(var taste: byte; var feld: string; var x, y: word; kurz: boolean);
var
  zeige: zeiger;
  warte: boolean;
begin
  repeat
    mausASM(m);
    zeige:= anker;
    while zeige <> nil do         {Feld suchen}
    begin
      if ((m[3] >= zeige^.x1) and (m[3] <= zeige^.x2) and
          (m[4] >= zeige^.y1) and (m[4] <= zeige^.y2)) then
      begin
        feld:= zeige^.name;
        if aktcursor <> zeige^.cursor then cursorWechsel( zeige^.cursor );
        warte:= zeige^.warte;
        beschreibung(zeige^.beschreib, m[3], m[4]);
        zeige:= nil;
      end
      else zeige:= zeige^.naechstes;
    end;
  until (m[2] > 0) or kurz;
  taste:= m[2];
  if warte and (taste > 0) then {warten bis losgelassen}
  begin
    repeat mausasm(m) until m[2] = 0;
    zeige:= anker;
    while zeige <> nil do         {Feld suchen}
    begin
      if ((m[3] >= zeige^.x1) and (m[3] <= zeige^.x2) and
          (m[4] >= zeige^.y1) and (m[4] <= zeige^.y2)) then
      begin
        if feld <> zeige^.name then feld:= ''; {wenn feld gewechselt dann canceln}
        if aktcursor <> zeige^.cursor then cursorWechsel( zeige^.cursor );
        zeige:= nil;
      end
      else zeige:= zeige^.naechstes;
    end;
  end;
  x:= m[3];
  y:= m[4];
end;

procedure ende;
var
  temp : zeiger;
begin
  while anker <> nil do
  begin
    temp:= anker;
    anker:= anker^.naechstes;
    dispose(temp);
  end;
end;

end.